Module javafx.graphics
Package javafx.scene.shape

# Class QuadCurve

java.lang.Object
javafx.scene.Node
javafx.scene.shape.Shape
javafx.scene.shape.QuadCurve

All Implemented Interfaces:
  `Styleable`, `EventTarget`

public class QuadCurve extends Shape
The `Quadcurve` class defines a quadratic Bézier parametric curve segment in (x,y) coordinate space. Drawing a curve that intersects both the specified coordinates `(startX, startY)` and `(endX, enfY)`, using the specified point `(controlX, controlY)` as Bézier control point.

    import javafx.scene.shape.*;

    QuadCurve quad = new QuadCurve();
    quad.setStartX(0.0f);
    quad.setStartY(50.0f);
    quad.setEndX(50.0f);
    quad.setEndY(50.0f);
    quad.setControlX(25.0f);
    quad.setControlY(0.0f);

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final DoubleProperty`
  `controlX`
  Defines the X coordinate of the control point of the quadratic curve segment.
  `final DoubleProperty`
  `controlY`
  Defines the Y coordinate of the control point of the quadratic curve segment.
  `final DoubleProperty`
  `endX`
  Defines the X coordinate of the end point of the quadratic curve segment.
  `final DoubleProperty`
  `endY`
  Defines the Y coordinate of the end point of the quadratic curve segment.
  `final DoubleProperty`
  `startX`
  Defines the X coordinate of the start point of the quadratic curve segment.
  `final DoubleProperty`
  `startY`
  Defines the Y coordinate of the start point of the quadratic curve segment.

  ### Properties declared in class javafx.scene.shape.Shape

  `fill, smooth, strokeDashOffset, strokeLineCap, strokeLineJoin, strokeMiterLimit, stroke, strokeType, strokeWidth`

  ### Properties declared in class javafx.scene.Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, focusVisible, focusWithin, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields declared in class javafx.scene.Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `QuadCurve()`
  Creates an empty instance of QuadCurve.
  `QuadCurve(double startX, double startY, double controlX, double controlY, double endX, double endY)`
  Creates a new instance of QuadCurve.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final DoubleProperty`
  `controlXProperty()`
  Defines the X coordinate of the control point of the quadratic curve segment.
  `final DoubleProperty`
  `controlYProperty()`
  Defines the Y coordinate of the control point of the quadratic curve segment.
  `final DoubleProperty`
  `endXProperty()`
  Defines the X coordinate of the end point of the quadratic curve segment.
  `final DoubleProperty`
  `endYProperty()`
  Defines the Y coordinate of the end point of the quadratic curve segment.
  `final double`
  `getControlX()`
  Gets the value of the `controlX` property.
  `final double`
  `getControlY()`
  Gets the value of the `controlY` property.
  `final double`
  `getEndX()`
  Gets the value of the `endX` property.
  `final double`
  `getEndY()`
  Gets the value of the `endY` property.
  `final double`
  `getStartX()`
  Gets the value of the `startX` property.
  `final double`
  `getStartY()`
  Gets the value of the `startY` property.
  `final void`
  `setControlX(double value)`
  Sets the value of the `controlX` property.
  `final void`
  `setControlY(double value)`
  Sets the value of the `controlY` property.
  `final void`
  `setEndX(double value)`
  Sets the value of the `endX` property.
  `final void`
  `setEndY(double value)`
  Sets the value of the `endY` property.
  `final void`
  `setStartX(double value)`
  Sets the value of the `startX` property.
  `final void`
  `setStartY(double value)`
  Sets the value of the `startY` property.
  `final DoubleProperty`
  `startXProperty()`
  Defines the X coordinate of the start point of the quadratic curve segment.
  `final DoubleProperty`
  `startYProperty()`
  Defines the Y coordinate of the start point of the quadratic curve segment.
  `String`
  `toString()`
  Returns a string representation of this `QuadCurve` object.

  ### Methods declared in class javafx.scene.shape.Shape

  `fillProperty, getClassCssMetaData, getCssMetaData, getFill, getStroke, getStrokeDashArray, getStrokeDashOffset, getStrokeLineCap, getStrokeLineJoin, getStrokeMiterLimit, getStrokeType, getStrokeWidth, intersect, isSmooth, setFill, setSmooth, setStroke, setStrokeDashOffset, setStrokeLineCap, setStrokeLineJoin, setStrokeMiterLimit, setStrokeType, setStrokeWidth, smoothProperty, strokeDashOffsetProperty, strokeLineCapProperty, strokeLineJoinProperty, strokeMiterLimitProperty, strokeProperty, strokeTypeProperty, strokeWidthProperty, subtract, union`

  ### Methods declared in class javafx.scene.Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, focusVisibleProperty, focusWithinProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBaselineOffset, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isFocusVisible, isFocusWithin, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookup, lookupAll, managedProperty, maxHeight, maxWidth, minHeight, minWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, prefHeight, prefWidth, pressedProperty, pseudoClassStateChanged, queryAccessibleAttribute, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.css.Styleable

  `getStyleableNode`

- ## Property Details

  - ### startX

    public final DoubleProperty startXProperty
    Defines the X coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    See Also:
      - `getStartX()`
      - `setStartX(double)`
      - `startXProperty()`

  - ### startY

    public final DoubleProperty startYProperty
    Defines the Y coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    See Also:
      - `getStartY()`
      - `setStartY(double)`
      - `startYProperty()`

  - ### controlX

    public final DoubleProperty controlXProperty
    Defines the X coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlX()`
      - `setControlX(double)`
      - `controlXProperty()`

  - ### controlY

    public final DoubleProperty controlYProperty
    Defines the Y coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    See Also:
      - `getControlY()`
      - `setControlY(double)`
      - `controlYProperty()`

  - ### endX

    public final DoubleProperty endXProperty
    Defines the X coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    See Also:
      - `getEndX()`
      - `setEndX(double)`
      - `endXProperty()`

  - ### endY

    public final DoubleProperty endYProperty
    Defines the Y coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    See Also:
      - `getEndY()`
      - `setEndY(double)`
      - `endYProperty()`

- ## Constructor Details

  - ### QuadCurve

    public QuadCurve()
    Creates an empty instance of QuadCurve.

  - ### QuadCurve

    public QuadCurve(double startX, double startY, double controlX, double controlY, double endX, double endY)
    Creates a new instance of QuadCurve.
    Parameters:
      `startX` - the X coordinate of the start point
      `startY` - the Y coordinate of the start point
      `controlX` - the X coordinate of the control point
      `controlY` - the Y coordinate of the control point
      `endX` - the X coordinate of the end point
      `endY` - the Y coordinate of the end point

- ## Method Details

  - ### setStartX

    public final void setStartX(double value)
    Sets the value of the `startX` property.
    Property description:
      Defines the X coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `startX` property
    See Also:
      - `getStartX()`
      - `startXProperty()`

  - ### getStartX

    public final double getStartX()
    Gets the value of the `startX` property.
    Property description:
      Defines the X coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the value of the `startX` property
    See Also:
      - `setStartX(double)`
      - `startXProperty()`

  - ### startXProperty

    public final DoubleProperty startXProperty()
    Defines the X coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the `startX` property
    See Also:
      - `getStartX()`
      - `setStartX(double)`

  - ### setStartY

    public final void setStartY(double value)
    Sets the value of the `startY` property.
    Property description:
      Defines the Y coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `startY` property
    See Also:
      - `getStartY()`
      - `startYProperty()`

  - ### getStartY

    public final double getStartY()
    Gets the value of the `startY` property.
    Property description:
      Defines the Y coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the value of the `startY` property
    See Also:
      - `setStartY(double)`
      - `startYProperty()`

  - ### startYProperty

    public final DoubleProperty startYProperty()
    Defines the Y coordinate of the start point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the `startY` property
    See Also:
      - `getStartY()`
      - `setStartY(double)`

  - ### setControlX

    public final void setControlX(double value)
    Sets the value of the `controlX` property.
    Property description:
      Defines the X coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `controlX` property
    See Also:
      - `getControlX()`
      - `controlXProperty()`

  - ### getControlX

    public final double getControlX()
    Gets the value of the `controlX` property.
    Property description:
      Defines the X coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the value of the `controlX` property
    See Also:
      - `setControlX(double)`
      - `controlXProperty()`

  - ### controlXProperty

    public final DoubleProperty controlXProperty()
    Defines the X coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the `controlX` property
    See Also:
      - `getControlX()`
      - `setControlX(double)`

  - ### setControlY

    public final void setControlY(double value)
    Sets the value of the `controlY` property.
    Property description:
      Defines the Y coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `controlY` property
    See Also:
      - `getControlY()`
      - `controlYProperty()`

  - ### getControlY

    public final double getControlY()
    Gets the value of the `controlY` property.
    Property description:
      Defines the Y coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the value of the `controlY` property
    See Also:
      - `setControlY(double)`
      - `controlYProperty()`

  - ### controlYProperty

    public final DoubleProperty controlYProperty()
    Defines the Y coordinate of the control point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the `controlY` property
    See Also:
      - `getControlY()`
      - `setControlY(double)`

  - ### setEndX

    public final void setEndX(double value)
    Sets the value of the `endX` property.
    Property description:
      Defines the X coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `endX` property
    See Also:
      - `getEndX()`
      - `endXProperty()`

  - ### getEndX

    public final double getEndX()
    Gets the value of the `endX` property.
    Property description:
      Defines the X coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the value of the `endX` property
    See Also:
      - `setEndX(double)`
      - `endXProperty()`

  - ### endXProperty

    public final DoubleProperty endXProperty()
    Defines the X coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the `endX` property
    See Also:
      - `getEndX()`
      - `setEndX(double)`

  - ### setEndY

    public final void setEndY(double value)
    Sets the value of the `endY` property.
    Property description:
      Defines the Y coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `endY` property
    See Also:
      - `getEndY()`
      - `endYProperty()`

  - ### getEndY

    public final double getEndY()
    Gets the value of the `endY` property.
    Property description:
      Defines the Y coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the value of the `endY` property
    See Also:
      - `setEndY(double)`
      - `endYProperty()`

  - ### endYProperty

    public final DoubleProperty endYProperty()
    Defines the Y coordinate of the end point of the quadratic curve segment.
    Default value:
      0.0
    Returns:
      the `endY` property
    See Also:
      - `getEndY()`
      - `setEndY(double)`

  - ### toString

    public String toString()
    Returns a string representation of this `QuadCurve` object.
    Overrides:
      `toString` in class `Node`
    Returns:
      a string representation of this `QuadCurve` object.